--#include "heist.lua"

function init()
    piston = FindJoint("piston",true)
    rot1 = FindJoint("rot1",true)    
    rot2 = FindJoint("rot2",true)   
    button_up = FindShape("button_up", true)
    button_down = FindShape("button_down",true)
    button_tilt = FindShape("button_tilt", true)
    button_level = FindShape("button_level",true)
    
    SetTag(button_up, "interact", "Up")
    SetTag(button_down, "interact", "Down")
    SetTag(button_tilt, "interact", "flip")
    SetTag(button_level, "interact", "level")
	movingUp = false	
	movingDown = false
end

function operate()
	if GetJointMovement(piston) > 0 then -- we dont want the piston to go below its start position (funny thing: below the start position is negative for the joint because of its rotation)
		SetJointMotor(piston,0.5) -- whenever we would go further down than we should, we raise the piston again at speed 0.1
		movingDown = false -- the piston moved down to here before, we have to stop him from moving furter down in the code below
	elseif GetJointMovement(piston) < -0.6 then -- same as above but in the other direction
		SetJointMotor(piston,-0.5)
		movingUp = false
	else 		
		if IsShapeOperated(button_up) then 
			movingUp = true
			movingDown = false
		elseif IsShapeOperated(button_down) then 
			movingDown = true
			movingUp = false
		end

		if movingUp then -- move the piston up with speed 0.2 if the up button is pressed or we pressed the button before and we are not at our limit yet
			SetJointMotor(piston, 1.0)				
		elseif movingDown then -- move the piston down with speed 0.2 if the up button is pressed or we pressed the button before and we are not at our limit yet
			SetJointMotor(piston, -1.0)			
		else
			SetJointMotor(piston, 0) -- stop moving the piston if none of our both variables are true, so no button pressed or the limit is reached
		end
	end
end	

function flip()
    if IsShapeOperated(button_tilt)
end

function tick(dt)    
	operate()
	flip()
end